<?php
// $Id: solr_service.inc,v 1.1.2.1 2009/05/20 09:20:36 aufumy Exp $
/**
 * @author Audrey Foo
 * @file
 *  Link apache solr search functionalities to services module.
 */

/**
 * Callback for search.solr service.
 */
function solr_service_results($keys, $fields = FALSE, $page = 0) {
  $stdkeys = explode(',', str_replace(' ', '', $fields));
  $results = array();
  watchdog('solr_service', t('search.solr invoked for !keys', array('!keys' => $keys)));

  try {
    $results = apachesolr_search_execute($keys, '', '', '', $page);
  }
  catch (Exception $e) {
    watchdog('solr_service', $e->getMessage(), NULL, WATCHDOG_ERROR);
    apachesolr_failure(t('Solr search'), $keys);
  }

  watchdog('solr_service', t('search.solr returned !count results for !keys', array('!count' => count($results),'!keys' => $keys)));

  if ($results and is_array($results) and count($results)) {
    // if specific fields requested, remove extra data
    if ($fields) {
      $num = count($results);
      for ($i = 0; $i<$num; $i++) {
        $keys = array_keys($results[$i]);
        foreach ($keys as $key) {
          if (!in_array($key, $stdkeys)) {
            unset($results[$i][$key]);
          }
        }
      }
    }
    $response = apachesolr_static_response_cache();
    $results['total'] = $response->response->numFound;
    return $results;
  }
  return services_error(t('Search returned no results.'));
}
